using System;

namespace Server.Core
{
    public abstract class SingleInstance
    {
    }

    public abstract class SingleInstance<T> : SingleInstance where T : SingleInstance,new()
    {
        private static T _instance;

        private static readonly Object instaceLock = new Object();
        
        public static T Instance
        {
            get
            {
                if (_instance == null)
                {
                    lock (instaceLock)
                    {
                        if (_instance == null)
                        {
                            _instance = new T();
                        }
                    }
                }

                return _instance;
            }
        }

    }
}